Metrics by Unit in JavaScript

Using ApexCharts with JavaScript

This Metrics by Unit example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// Three metrics in three units: dollars, percent, people. They cannot share
// an axis, and a dual-axis chart is the most misread chart there is. The
// 2-D answer: rows = metric, columns = business unit, and
// `scales.y: 'independent-row'` gives each METRIC one shared domain across
// its row. Along a row the units are directly comparable (identical ticks);
// across rows each metric keeps its own honest scale.
//
// Deterministic monthly walks so the e2e snapshot is stable.
function mulberry32(seed) {
  return function () {
    seed |= 0
    seed = (seed + 0x6d2b79f5) | 0
    var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}

function monthly(seed, base, drift, vol) {
  var rand = mulberry32(seed)
  var out = []
  var ts = new Date('01 Jan 2025').getTime()
  var val = base
  for (var i = 0; i < 12; i++) {
    val = Math.max(1, val + drift + (rand() - 0.5) * vol)
    out.push([ts, Math.round(val * 10) / 10])
    ts += 2678400000 // ~1 month
  }
  return out
}

var UNITS = [
  { unit: 'North America', seed: 3 },
  { unit: 'Europe', seed: 41 },
  { unit: 'APAC', seed: 89 },
]

var metricSeries = []
UNITS.forEach(function (u, i) {
  metricSeries.push({
    name: 'value',
    metric: 'Revenue',
    unit: u.unit,
    data: monthly(u.seed, 420 - i * 90, 14 - i * 3, 60),
  })
  metricSeries.push({
    name: 'value',
    metric: 'Margin',
    unit: u.unit,
    // Europe's margin erodes: visible only because the row shares a scale.
    data: monthly(
      u.seed + 7,
      24 + i * 2,
      u.unit === 'Europe' ? -0.9 : 0.1,
      2.4,
    ),
  })
  metricSeries.push({
    name: 'value',
    metric: 'Headcount',
    unit: u.unit,
    data: monthly(u.seed + 13, 120 - i * 30, 2, 8),
  })
})

var options = {
  series: metricSeries,
  chart: {
    id: 'metricsTrellis',
    type: 'line',
    height: 560,
    animations: {
      enabled: false,
    },
  },
  trellis: {
    row: 'metric',
    column: 'unit',
    gap: 12,
    scales: {
      y: 'independent-row',
    },
    panel: function (key) {
      if (key.indexOf('Revenue') === 0) {
        return {
          yaxis: {
            labels: {
              formatter: function (val) {
                return '$' + Math.round(val) + 'k'
              },
            },
          },
        }
      }
      if (key.indexOf('Margin') === 0) {
        return {
          yaxis: {
            labels: {
              formatter: function (val) {
                return Math.round(val) + '%'
              },
            },
          },
        }
      }
      return {
        yaxis: {
          labels: {
            formatter: function (val) {
              return String(Math.round(val))
            },
          },
        },
      }
    },
  },
  colors: ['#0D9488'],
  stroke: {
    width: 2.5,
    curve: 'straight',
  },
  xaxis: {
    type: 'datetime',
  },
  dataLabels: {
    enabled: false,
  },
  tooltip: {
    x: {
      format: 'MMM yyyy',
    },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Metrics by Unit in Angular

Using ApexCharts with Angular

This Metrics by Unit example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private mulberry32 = (seed: any): any => {
        return function () {
          seed |= 0
          seed = (seed + 0x6d2b79f5) | 0
          var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
          t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
          return ((t ^ (t >>> 14)) >>> 0) / 4294967296
        }
      };

  private monthly = (seed: any, base: any, drift: any, vol: any): any => {
        var rand = this.mulberry32(seed)
        var out = []
        var ts = new Date('01 Jan 2025').getTime()
        var val = base
        for (var i = 0; i < 12; i++) {
          val = Math.max(1, val + drift + (rand() - 0.5) * vol)
          out.push([ts, Math.round(val * 10) / 10])
          ts += 2678400000 // ~1 month
        }
        return out
      };

  private UNITS: any = [
        { unit: 'North America', seed: 3 },
        { unit: 'Europe', seed: 41 },
        { unit: 'APAC', seed: 89 },
      ];

  private metricSeries: any = [];

  public chartOptions: Partial<ChartOptions> = {
          series: this.metricSeries,
          chart: {
            id: 'metricsTrellis',
            type: 'line',
            height: 560,
            animations: {
              enabled: false,
            },
          },
          trellis: {
            row: 'metric',
            column: 'unit',
            gap: 12,
            scales: {
              y: 'independent-row',
            },
            panel: (key) => {
              if (key.indexOf('Revenue') === 0) {
                return {
                  yaxis: {
                    labels: {
                      formatter: function (val) {
                        return '$' + Math.round(val) + 'k'
                      },
                    },
                  },
                }
              }
              if (key.indexOf('Margin') === 0) {
                return {
                  yaxis: {
                    labels: {
                      formatter: function (val) {
                        return Math.round(val) + '%'
                      },
                    },
                  },
                }
              }
              return {
                yaxis: {
                  labels: {
                    formatter: function (val) {
                      return String(Math.round(val))
                    },
                  },
                },
              }
            }   colors: ['#0D9488'],
          stroke: {
            width: 2.5,
            curve: 'straight',
          },
          xaxis: {
            type: 'datetime',
          },
          dataLabels: {
            enabled: false,
          },
          tooltip: {
            x: {
              format: 'MMM yyyy',
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
    this.UNITS.forEach(function (u, i) {
          this.metricSeries.push({
            name: 'value',
            metric: 'Revenue',
            unit: u.unit,
            data: this.monthly(u.seed, 420 - i * 90, 14 - i * 3, 60),
          })
          this.metricSeries.push({
            name: 'value',
            metric: 'Margin',
            unit: u.unit,
            // Europe's margin erodes: visible only because the row shares a scale.
            data: this.monthly(
              u.seed + 7,
              24 + i * 2,
              u.unit === 'Europe' ? -0.9 : 0.1,
              2.4,
            ),
          })
          this.metricSeries.push({
            name: 'value',
            metric: 'Headcount',
            unit: u.unit,
            data: this.monthly(u.seed + 13, 120 - i * 30, 2, 8),
          })
        })
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Metrics by Unit in React

Using ApexCharts with React

This Metrics by Unit example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

import 'apexcharts/features/trellis'

// Three metrics in three units: dollars, percent, people. They cannot share
// an axis, and a dual-axis chart is the most misread chart there is. The
// 2-D answer: rows = metric, columns = business unit, and
// `scales.y: 'independent-row'` gives each METRIC one shared domain across
// its row. Along a row the units are directly comparable (identical ticks);
// across rows each metric keeps its own honest scale.
//
// Deterministic monthly walks so the e2e snapshot is stable.
function mulberry32(seed) {
  return function () {
    seed |= 0
    seed = (seed + 0x6d2b79f5) | 0
    var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}

function monthly(seed, base, drift, vol) {
  var rand = mulberry32(seed)
  var out = []
  var ts = new Date('01 Jan 2025').getTime()
  var val = base
  for (var i = 0; i < 12; i++) {
    val = Math.max(1, val + drift + (rand() - 0.5) * vol)
    out.push([ts, Math.round(val * 10) / 10])
    ts += 2678400000 // ~1 month
  }
  return out
}

var UNITS = [
  { unit: 'North America', seed: 3 },
  { unit: 'Europe', seed: 41 },
  { unit: 'APAC', seed: 89 },
]

var metricSeries = []
UNITS.forEach(function (u, i) {
  metricSeries.push({
    name: 'value',
    metric: 'Revenue',
    unit: u.unit,
    data: monthly(u.seed, 420 - i * 90, 14 - i * 3, 60),
  })
  metricSeries.push({
    name: 'value',
    metric: 'Margin',
    unit: u.unit,
    // Europe's margin erodes: visible only because the row shares a scale.
    data: monthly(
      u.seed + 7,
      24 + i * 2,
      u.unit === 'Europe' ? -0.9 : 0.1,
      2.4,
    ),
  })
  metricSeries.push({
    name: 'value',
    metric: 'Headcount',
    unit: u.unit,
    data: monthly(u.seed + 13, 120 - i * 30, 2, 8),
  })
})

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: metricSeries,
    options: {
      chart: {
        id: 'metricsTrellis',
        type: 'line',
        height: 560,
        animations: {
          enabled: false,
        },
      },
      trellis: {
        row: 'metric',
        column: 'unit',
        gap: 12,
        scales: {
          y: 'independent-row',
        },
        panel: function (key) {
          if (key.indexOf('Revenue') === 0) {
            return {
              yaxis: {
                labels: {
                  formatter: function (val) {
                    return '$' + Math.round(val) + 'k'
                  },
                },
              },
            }
          }
          if (key.indexOf('Margin') === 0) {
            return {
              yaxis: {
                labels: {
                  formatter: function (val) {
                    return Math.round(val) + '%'
                  },
                },
              },
            }
          }
          return {
            yaxis: {
              labels: {
                formatter: function (val) {
                  return String(Math.round(val))
                },
              },
            },
          }
        },
      },
      colors: ['#0D9488'],
      stroke: {
        width: 2.5,
        curve: 'straight',
      },
      xaxis: {
        type: 'datetime',
      },
      dataLabels: {
        enabled: false,
      },
      tooltip: {
        x: {
          format: 'MMM yyyy',
        },
      },
    },
  })

  return (
    <div>
      <div className="wrap">
        <h1>Three metrics, three units, no dual axis</h1>
        <p className="lead">
          Each row is one metric on one honest scale: compare units left to
          right. Each column is one unit top to bottom. Europe's margin erosion
          is unmissable because the whole Margin row shares its domain, and no
          axis pretends dollars and percent are the same thing.
        </p>

        <div className="chart-wrap">
          <div id="chart">
            <ReactApexChart
              options={state.options}
              series={state.series}
              type="line"
              height={560}
            />
          </div>
        </div>

        <div className="note">
          <code>scales.y: 'independent-row'</code> computes ONE domain per row
          (the union across that row's panels) so ticks are identical along a
          row and different across rows; the y labels draw on the first column
          only, because the row's left edge speaks for the whole row. Per-row
          units come from <code>trellis.panel</code>: the Margin row formats as
          percent, the Revenue row as dollars. The grid stays pixel-aligned
          across rows via the measured shared gutter. Trellis is a premium
          feature; without a license it renders with a trial watermark.
        </div>
      </div>
    </div>
  )
}

export default ApexChart

Metrics by Unit in Vue

Using ApexCharts with Vue

This Metrics by Unit example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div class="wrap">
      <h1>Three metrics, three units, no dual axis</h1>
      <p class="lead">
        Each row is one metric on one honest scale: compare units left to right.
        Each column is one unit top to bottom. Europe's margin erosion is
        unmissable because the whole Margin row shares its domain, and no axis
        pretends dollars and percent are the same thing.
      </p>

      <div class="chart-wrap">
        <div id="chart">
          <apexchart
            type="line"
            height="560"
            :options="chartOptions"
            :series="series"
          ></apexchart>
        </div>
      </div>

      <div class="note">
        <code>scales.y: 'independent-row'</code> computes ONE domain per row
        (the union across that row's panels) so ticks are identical along a row
        and different across rows; the y labels draw on the first column only,
        because the row's left edge speaks for the whole row. Per-row units come
        from <code>trellis.panel</code>: the Margin row formats as percent, the
        Revenue row as dollars. The grid stays pixel-aligned across rows via the
        measured shared gutter. Trellis is a premium feature; without a license
        it renders with a trial watermark.
      </div>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

import 'apexcharts/features/trellis'

// Three metrics in three units: dollars, percent, people. They cannot share
// an axis, and a dual-axis chart is the most misread chart there is. The
// 2-D answer: rows = metric, columns = business unit, and
// `scales.y: 'independent-row'` gives each METRIC one shared domain across
// its row. Along a row the units are directly comparable (identical ticks);
// across rows each metric keeps its own honest scale.
//
// Deterministic monthly walks so the e2e snapshot is stable.
function mulberry32(seed) {
  return function () {
    seed |= 0
    seed = (seed + 0x6d2b79f5) | 0
    var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}

function monthly(seed, base, drift, vol) {
  var rand = mulberry32(seed)
  var out = []
  var ts = new Date('01 Jan 2025').getTime()
  var val = base
  for (var i = 0; i < 12; i++) {
    val = Math.max(1, val + drift + (rand() - 0.5) * vol)
    out.push([ts, Math.round(val * 10) / 10])
    ts += 2678400000 // ~1 month
  }
  return out
}

var UNITS = [
  { unit: 'North America', seed: 3 },
  { unit: 'Europe', seed: 41 },
  { unit: 'APAC', seed: 89 },
]

var metricSeries = []
UNITS.forEach(function (u, i) {
  metricSeries.push({
    name: 'value',
    metric: 'Revenue',
    unit: u.unit,
    data: monthly(u.seed, 420 - i * 90, 14 - i * 3, 60),
  })
  metricSeries.push({
    name: 'value',
    metric: 'Margin',
    unit: u.unit,
    // Europe's margin erodes: visible only because the row shares a scale.
    data: monthly(
      u.seed + 7,
      24 + i * 2,
      u.unit === 'Europe' ? -0.9 : 0.1,
      2.4,
    ),
  })
  metricSeries.push({
    name: 'value',
    metric: 'Headcount',
    unit: u.unit,
    data: monthly(u.seed + 13, 120 - i * 30, 2, 8),
  })
})

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: metricSeries,
      chartOptions: {
        chart: {
          id: 'metricsTrellis',
          type: 'line',
          height: 560,
          animations: {
            enabled: false,
          },
        },
        trellis: {
          row: 'metric',
          column: 'unit',
          gap: 12,
          scales: {
            y: 'independent-row',
          },
          panel: function (key) {
            if (key.indexOf('Revenue') === 0) {
              return {
                yaxis: {
                  labels: {
                    formatter: function (val) {
                      return '$' + Math.round(val) + 'k'
                    },
                  },
                },
              }
            }
            if (key.indexOf('Margin') === 0) {
              return {
                yaxis: {
                  labels: {
                    formatter: function (val) {
                      return Math.round(val) + '%'
                    },
                  },
                },
              }
            }
            return {
              yaxis: {
                labels: {
                  formatter: function (val) {
                    return String(Math.round(val))
                  },
                },
              },
            }
          },
        },
        colors: ['#0D9488'],
        stroke: {
          width: 2.5,
          curve: 'straight',
        },
        xaxis: {
          type: 'datetime',
        },
        dataLabels: {
          enabled: false,
        },
        tooltip: {
          x: {
            format: 'MMM yyyy',
          },
        },
      },
    }
  },
}
</script>

<style>
body {
  font-family:
    -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, sans-serif;
  background: #fafbfc;
  color: #2c3e50;
  margin: 0;
  padding: 32px 16px;
}
.wrap {
  max-width: 1040px;
  margin: 0 auto;
}
h1 {
  font-size: 22px;
  margin: 0 0 8px;
}
.lead {
  color: #5b6b78;
  line-height: 1.5;
  margin: 0 0 20px;
}
.chart-wrap {
  background: #fff;
  border-radius: 8px;
  padding: 16px;
  box-shadow: 0 2px 10px rgba(0, 0, 0, 0.04);
}
.note {
  background: #f0fdfa;
  border-left: 3px solid #0d9488;
  padding: 12px 16px;
  font-size: 13px;
  color: #333;
  border-radius: 2px;
  line-height: 1.6;
  margin: 26px auto 0;
}
.note code {
  background: #ccfbf1;
  padding: 1px 5px;
  border-radius: 3px;
}
</style>